/*
  opciones.cpp
*/
#include "rotuloTexto.h"
#include "rotuloHanzi.h"
#include "rotuloPinyin.h"
#include "opciones.h"
#include <stdlib.h>
#include <string.h>
#include "global.h"

typedef void (*funcion) (Widget,void *);


void Opciones::static_boton(Widget w, Opciones *o)
{
  o->boton_on(w);
}

void Opciones::boton_on(Widget w)
{
 int i,b=-1;

  if(GetToggleState(w))
  {
    for(i=0;i<opciones;i++)
      if(GetToggleState(boton[i])) b=i;
    if(b==-1) return;
    SetToggleState(boton[b],FALSE);
    if(!strcmp(a.resp,txt[b]->getRotulo()))
    {
       d->rotar();
       numero--;
       if(!numero) acabar();	
       dibujarDatos();
    }
    else
    {
	Beep();
    }
  }
}

void Opciones::static_acabar(Widget, Opciones *o)
{
  o->acabar();
}

void Opciones::acabar()
{
   SetCurrentWindow(ventana);
   CloseWindow();
}


Opciones::Opciones(Datos *dat,int t):
a(dat)
{
   buffer=0;
   tipo=t;
   d=dat;
   numero=d->numero();
   ventana = MakeWindow(S_8,SAME_DISPLAY,EXCLUSIVE_WINDOW);
   forma = MakeForm(ventana, NO_CARE, NULL, NO_CARE, NULL);
  switch(tipo)
   {
      case 1:
	txt1 =   new RotuloHanzi();
	txt2 =   new RotuloPinyin();
        for (int i=0;i<opciones;i++)
          txt[i] = new RotuloTexto();
        break;
      case 2:
	txt1 =   new RotuloHanzi();
	txt2 =   new RotuloTexto();
        for (int i=0;i<opciones;i++)
          txt[i] = new RotuloPinyin();
        break;
      case 3:
	txt1 =   new RotuloTexto();
	txt2 =   new RotuloPinyin();
        for (int i=0;i<opciones;i++)
          txt[i] = new RotuloHanzi();
        break;
      case 4:
	txt1 =   new RotuloPinyin();
	txt2 =   new RotuloTexto();
        for (int i=0;i<opciones;i++)
          txt[i] = new RotuloHanzi();
        break;
      	
  }
  
bAcabar = MakeButton(S_15, (funcion )static_acabar, this);
  for (int i=0;i<opciones;i++)
     boton[i] =MakeToggle("x",FALSE,NULL,(funcion)static_boton,this);
  SetWidgetPos(txt2->w, PLACE_UNDER,txt1->w,NO_CARE, NULL);
  SetWidgetPos(boton[0], PLACE_UNDER,txt2->w,NO_CARE, NULL);
  SetWidgetPos(txt[0]->w, PLACE_UNDER,txt2->w,PLACE_RIGHT, boton[0]);
  for(int i=1;i<opciones;i++)
  {
    SetWidgetPos(boton[i], PLACE_UNDER,txt[i-1]->w,NO_CARE, NULL);
    SetWidgetPos(txt[i]->w, PLACE_UNDER,txt[i-1]->w,PLACE_RIGHT, boton[i]);
  }
    SetWidgetPos(bAcabar, PLACE_UNDER,txt[opciones-1]->w,NO_CARE, NULL);
 
}

Opciones::~Opciones()
{
  delete txt1;
  delete txt2;
  for (int i=0; i<opciones; i++)
    delete txt[i];
}


void Opciones::dibujarDatos()
{
  int i;
  a.sorteo(tipo);

  txt1->escribir(a.r[0]);
  txt2->escribir(a.r1);


for (i=0;i<opciones;i++)
   txt[i]->escribir(a.r[i+1]);
}


void Opciones::ejecutar()
{
  if(d->numero()<opciones) return;
  d->barajar();
  ShowDisplay();
  dibujarDatos();
  MainLoop();
  SetCurrentWindow(ORIGINAL_WINDOW);
}
