/* tarjeta.cpp */
extern "C"
{
#include "libsx.h"
}
#include "tarjeta.h"
#include "rotuloTexto.h"
#include "rotuloHanzi.h"
#include "rotuloPinyin.h"
#include "global.h"

typedef void (*funcion) (Widget,void *);



void Tarjeta::static_acabar(Widget, Tarjeta *t)
{
  t->acabar();
}

void Tarjeta::acabar()
{
   SetCurrentWindow(ventana);
   CloseWindow();
}

Tarjeta::Tarjeta(Datos *dat,int t)
{

  ventana = MakeWindow(S_4,SAME_DISPLAY,EXCLUSIVE_WINDOW);
  forma = MakeForm(ventana, NO_CARE, NULL, NO_CARE, NULL);
  tipo=t;
  switch(t)
  {
  case 1:
  	txt[0] = new RotuloHanzi();
  	txt[1] = new RotuloPinyin();
  	txt[2] = new RotuloTexto();
	break;
  case 2:
  	txt[0] = new RotuloPinyin();
  	txt[1] = new RotuloHanzi();
  	txt[2] = new RotuloTexto();
	break;
  case 3:
  	txt[0] = new RotuloTexto();
  	txt[1] = new RotuloPinyin();
  	txt[2] = new RotuloHanzi();
	break;
  }
  bSiguiente = MakeButton(S_14, (funcion)static_siguiente, this);
  bAcabar = MakeButton(S_15, (funcion )static_acabar, this);
  SetWidgetPos(txt[1]->w, PLACE_UNDER,txt[0]->w,NO_CARE, NULL);
  SetWidgetPos(txt[2]->w, PLACE_UNDER,txt[1]->w,NO_CARE, NULL);
  SetWidgetPos(bSiguiente, PLACE_UNDER,txt[2]->w,NO_CARE, NULL);
  SetWidgetPos(bAcabar, PLACE_UNDER,txt[2]->w,PLACE_RIGHT,bSiguiente);
   d=dat;
   rotulo=0;
   numero=dat->numero();
}


Tarjeta::~Tarjeta()
{
  delete txt[0];
  delete txt[1];
  delete txt[2];
}

void Tarjeta::siguiente()
{
  rotulo = (rotulo+1)%3;
  if(rotulo==0)
  {
    txt[0]->borrar();
    txt[1]->borrar();
    txt[2]->borrar();
    d->rotar();
    numero--;
    if(numero==0)
    {
      acabar();
    }
  }

  escribirRotulo();
}

void Tarjeta::static_siguiente(Widget, Tarjeta *t)
{
  t->siguiente();
}

void Tarjeta::escribirRotulo()
{
  switch(tipo)
  {
    case 1:
   	    switch(rotulo)
  	    {
  	        case 0: txt[0]->escribir(d->hanzi()); break;
	        case 1: txt[1]->escribir(d->pinyin()); break;
    		case 2: txt[2]->escribir(d->traduccion()); break;
	    }
	    break;
    case 2:
   	    switch(rotulo)
  	    {
	        case 0: txt[0]->escribir(d->pinyin()); break;
  	        case 1: txt[1]->escribir(d->hanzi()); break;
    		case 2: txt[2]->escribir(d->traduccion()); break;
	    }
	    break;
    case 3:
   	    switch(rotulo)
  	    {
    		case 0: txt[0]->escribir(d->traduccion()); break;
	        case 1: txt[1]->escribir(d->pinyin()); break;
  	        case 2: txt[2]->escribir(d->hanzi()); break;
	    }
	    break;
	}
}


void Tarjeta::ejecutar()
{
  d->barajar();
  ShowDisplay();
  escribirRotulo();
  MainLoop();
  SetCurrentWindow(ORIGINAL_WINDOW);
}
